#!/usr/bin/perl

# CYM Private Message v1.5
# based on Clarn's Message Center v2

# Required Librariers
# --------------------------------------------------------
eval {
    ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");    # Get the script location: UNIX /
    ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");    # Get the script location: Windows \

    require "buddy.cfg";
    require "buddy.pl";
	require "ubb_library.pl";
};

local (%in) = &parse_form;
        $user = $in{'user'};
        $pass = $in{'pass'};
        $ID   = $in{'ID'};
		$urluser = &htmlify($user);
		$urluser =~ tr/ /+/;
		$urlpass = &htmlify($pass);
		$urlpass =~ tr/ /+/;

###################################################################
#### Actual cgi program
###################################################################
unless ($user and $pass) {
&login;
}
&valid_user;
&valid_pass;
&delete_message;
&delete_success;
exit;
# End of program

###################################################################
sub delete_message {
###################################################################

    my ($key, %delete_list, $rec_to_delete, @data, $errstr, $succstr, $output);
    $rec_to_delete = 0;
    foreach $key (keys %in) {               # Build a hash of keys to delete.
        if ($in{$key} eq "delete") {
            $delete_list{$key} = 1;
            $rec_to_delete = 1;
        }
    }
    $rec_to_delete or (("Error: $html_object(s) Not Deleted", "no records specified.") and return);

# Search the database for a record to delete.
    open (DB, "<$db_dir/$user.db") or &cgierr("error in delete_records. unable to open db file: $db_file_name.\nReason: $!");
flock(DB, 1);
    LINE: while (<DB>) {
        (/^#/)      and ($output .= $_ and next LINE);
        (/^\s*$/)   and next LINE;
        chomp;      
        @data = &split_decode($_);

        $delete_list{$data[0]} ?              # if this id is one we want to delete
            ($delete_list{$data[0]} = 0) :    # then mark it deleted and don't print it to the new database.
            ($output .= "$_\n");                        # otherwise print it.
    }
    close DB;
    
# Reprint out the database.
if ($output ne "") {
	open (DB, ">$db_dir/$user.db") or &cgierr("error in delete_records. unable to open db file: $db_file_name.\nReason: $!");

            flock(DB, 2) or &cgierr("unable to get exclusive lock on $db_file_name.\nReason: $!");
       
        print DB $output;
    close DB;       # automatically removes file lock
}
else {
unlink("$db_dir/$user.db");
unlink("$db_dir/$user.count");
}

# Build success/error messages.
    foreach $key (keys %delete_list) {
        $delete_list{$key} ?                # Check to see if any items weren't deleted
            ($errstr .= "$key,") :          # that should have been.
            ($succstr .= "$key,");          # For logging, we'll remember the one's we deleted.
    }
    chop($succstr);     # Remove trailing delimeter
    chop($errstr);      # Remove trailing delimeter
}

###################################################################
sub delete_success {
###################################################################

print "Location: $cgi_url/$viewprivate?user=$urluser&pass=$urlpass\n\n";

}